---
title: IDBObjectStore.getKey()
slug: Web/API/IDBObjectStore/getKey
tags:
  - IBDObjectStore
  - IndexedDB
  - Method
  - Reference
  - Storage
  - Web API
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>getKey()</code></strong> method of the {{domxref("IDBObjectStore")}} interface returns an {{domxref("IDBRequest")}} object, and, in a separate thread, returns the key selected by the specified query. This is for retrieving specific records from an object store.</p>
</div>

<p>If a key is successfully found, then a structured clone of it is created and set as the result of the request object.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var request = <em>objectStore</em>.getKey(<em>key</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>key</em></dt>
 <dd>The key or key range that identifies the record to be retrieved.</dd>
</dl>

<h3 id="Return_Value">Return Value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This {{domxref("IDBObjectStore")}}'s transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>DataError</code></td>
   <td>
    <p>The key or key range provided contains an invalid key.</p>
   </td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("IDBObjectStore")}} has been deleted or removed.<br>
     </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<pre class="brush: js">let openRequest = indexedDB.open("telemetry");
openRequest.onsuccess = (event) =&gt; {
  let db = event.target.result;
  let store = db.transaction("netlogs").objectStore("netlogs");

  let today = new Date();
  let yesterday = new Date(today);
  yesterday.setDate(today.getDate() - 1);
  let request = store.getKey(IDBKeyRange(yesterday, today));
  request.onsuccess = (event) =&gt; {
    let when = event.target.result;
    alert("The 1st activity in last 24 hours was occurred at " + when);
  };
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB 2', '#dom-idbobjectstore-getkey', 'getKey()')}}</td>
   <td>{{Spec2('IndexedDB 2')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBObjectStore.getKey")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
